package de.huberlin.elab;

import de.huberlin.elab.pfw.*;
import java.util.Date;

public class ProduktProxy extends VirtualProxy
    implements Produkt
{

    protected ProduktProxy(Integer anOID)
    {
	super(anOID);
    }

    protected PFWBroker createBroker()
    {
	return ProduktRelationalBroker.getInstance();
    }
    
    public String getBezeichnung() 
    {
	ProduktImpl pi = (ProduktImpl)getRealSubject();
	if (pi!=null)
	    return pi.getBezeichnung();
	else
	    return null;
    }
	
    public double getPreis()
    {
	ProduktImpl pi = (ProduktImpl)getRealSubject();
	if (pi!=null)
	    return pi.getPreis();
	else
	    return 0.0d;
    }

    public String getBeschreibung()
    {
	ProduktImpl pi = (ProduktImpl)getRealSubject();
	if (pi!=null)
	    return pi.getBeschreibung();
	else
	    return null;
    }

    public String getBild()
    {
	ProduktImpl pi = (ProduktImpl)getRealSubject();
	if (pi!=null)
	    return pi.getBild();
	else
	    return null;
    }

    public Date getGueltigAb()
    {
	ProduktImpl pi = (ProduktImpl)getRealSubject();
	if (pi!=null)
	    return pi.getGueltigAb();
	else
	    return null;
    }

    public Date getGueltigBis()
    {
	ProduktImpl pi = (ProduktImpl)getRealSubject();
	if (pi!=null)
	    return pi.getGueltigBis();
	else
	    return null;
    }

}
