package de.huberlin.elab;

import java.util.Hashtable;
import java.util.Vector;
import java.sql.*;
/**
 * ProduktRelationalBroker.java
 *
 *
 * Created: Thu Jun 29 23:38:01 2000
 *
 * @author Erik Pischel
 * @version
 */

public class ProduktRelationalBroker 
    extends de.huberlin.elab.pfw.RelationalPFWBroker 
{
    
    public ProduktRelationalBroker() {
	 tableName = "Produkt";
	 oidColumn = "ProduktId";
    }

    protected Object currentRecordAsObject(Hashtable record)
    {
	if (record==null)
	    return null;

	ProduktImpl pi = new ProduktImpl();
	Object o = record.get("PRODUKTID");
	if (o!=null)
	    System.out.println("PRODUKTID:"+o+" ("+
			       o.getClass().getName()+")");
	else
	    System.out.println("PRODUKTID == null");
	
	o = record.get("BEZEICHUNG");
	if (o!=null) {
	    System.out.println("BEZEICHNUNG: "+o+" ("+
			       o.getClass().getName()+")");
	    pi.setBezeichnung(o.toString());
	}
	else
	    System.out.println("BEZEICHNUNG: null");

	o = record.get("BESCHREIBUNG");
	if (o!=null) {
	    
	    System.out.println("BESCHREIBUNG: "+o+" ("+
			       o.getClass().getName()+")");
	    System.out.println("ist byte[] -> "+(o instanceof byte[]));
	    if (o instanceof byte[])
		System.out.println(new String((byte[])o));
	    
	    pi.setBeschreibung(o.toString());
	    
	}
	else
	    System.out.println("BESCHREIBUNG: null");

	o = record.get("PREIS");
	if (o!=null) {
	    System.out.println("PREIS: "+o+" ("+
			       o.getClass().getName()+")");
	    pi.setPreis((new Double(o.toString())).doubleValue());
	}
	else
	    System.out.println("PREIS: null");

	o = record.get("GUELTIGAB");
	if (o!=null) {
	    System.out.println("GUELTIGAB: "+o+" ("+
			       o.getClass().getName()+")");
	    pi.setBeschreibung(o.toString());
	}
	else
	    System.out.println("GUELTIGAB: null");

	o = record.get("GUELTIGBIS");
	if (o!=null) {
	    System.out.println("GUELTIGBIS: "+o+" ("+
			       o.getClass().getName()+")");
	    pi.setBeschreibung(o.toString());
	}
	else
	    System.out.println("GUELTIGBIS: null");
	    
	    
	o = record.get("BILD");
	if (o!=null) {
	    System.out.println("BILD: "+o+" ("+
			       o.getClass().getName()+")");
	    pi.setBild(o.toString());
	}
	else
	    System.out.println("BILD: null");
	    
	    
	return pi;
    }

    /** Optimierte version zum holen aller Produkte. */
    public java.util.Enumeration getAlleProdukte()
    {
	java.util.Vector v= new java.util.Vector();
	Connection con = getConnection();
	if (con==null)
	    return null;
	try {
	    Statement stmt = con.createStatement();
	    String sqlquery =  "SELECT * FROM "+
		getTableName()+" WHERE GueltigAb<now() and GueltigBis>now()";
	    System.out.println("executing: "+sqlquery);	    
	    ResultSet rs = stmt.executeQuery(sqlquery);
	    
	    while (rs.next()) {
		ProduktImpl pi = new ProduktImpl();
		pi.setBezeichnung(rs.getString("Bezeichung"));
		pi.setBeschreibung(rs.getString("Beschreibung"));
		pi.setPreis(rs.getDouble("Preis"));
		pi.setBild(rs.getString("Bild"));
		pi.setGueltigAb(rs.getDate("GueltigAb"));
		pi.setGueltigBis(rs.getDate("GueltigBis"));
		Integer anOID = new Integer(rs.getInt("ProduktId"));
		myCache.add(anOID, pi,true);
		v.addElement(pi);
	    }
	    rs.close();
	    stmt.close();
	    con.close();
	    
	} catch(Exception e) {
	    System.out.println("ProduktRelationalPFWBroker ("+this.getClass()+
			       ")::getAlleProdukte -> "+e);
	    e.printStackTrace();
	}
	System.out.println("===ende getAlleProdukte=====");
	
	return v.elements();
    }


    
    
    static ProduktRelationalBroker instance = null;

    public static ProduktRelationalBroker getInstance()
    {
	if (instance==null)
	    instance=new ProduktRelationalBroker();
	return instance;
    }
	
    public static void main(String argv[])
    {
	Produkt p = (Produkt) getInstance().objectWith(new Integer(1));	
	System.out.println(p);
	java.util.Enumeration e= getInstance().getAlleProdukte();
	for(;e.hasMoreElements();) {
	    p = (Produkt) e.nextElement();
	    System.out.println(p.getBezeichnung());
	}
	
    }
    
    
} // ProduktRelationalBroker
