package de.huberlin.elab.pfw;

import java.util.Hashtable;
import java.sql.*;

/**
 * RelationalPFWBroker.java
 *
 *
 * Created: Thu Jun 29 23:09:41 2000
 *
 * @author Erik Pischel
 * @version
 */

public abstract class RelationalPFWBroker extends PFWBroker {

    protected String tableName = "dual";
    protected String oidColumn = "sysdate";

    protected String getTableName()
    {
	return tableName;
    }

    protected String getOIDColumn()
    {
	return oidColumn;
    }
    
    protected Hashtable selectFirst(String query)
    {
	Connection con = getConnection();
	if (con==null)
	    return null;
	Hashtable hs = new Hashtable();
	try {
	    Statement stmt = con.createStatement();
	    String sqlquery =  "SELECT * FROM "+
		getTableName()+" WHERE "+
		query;
	    System.out.println("executing: "+sqlquery);	    
	    ResultSet rs = stmt.executeQuery(sqlquery);

	    ResultSetMetaData rsmd = rs.getMetaData();	    
	    if (rs.next()) 
		for(int i = 1;i<=rsmd.getColumnCount();i++) {
		    Object o = rsmd.getColumnName(i).toUpperCase();
		    System.out.print(o+"  /  ");		    
		    Object p = rs.getObject(i);
		    System.out.println(p);
		    
		    hs.put(o,p);
		}
	    rs.close();
	    stmt.close();
	    con.close();
	    
	} catch(Exception e) {
	    System.out.println("RelationalPFWBroker ("+this.getClass()+
			       ")::selectFirst -> "+e);
	    e.printStackTrace();
	    hs = null;
	}
	return hs;
    }
    
    protected Connection getConnection()
    { 
	System.out.println("Aufruf getConnection");
 
	try {
	    
	    // The newInstance() call is a work around for some
	    // broken Java implementations
	    
	    Class.forName("org.gjt.mm.mysql.Driver").newInstance(); 
	    
	}
	catch (Exception E) {
	    System.err.println("Unable to load driver.");
	    E.printStackTrace();
	}
	Connection C = null;
	try {
	    C = DriverManager.getConnection(
					    "jdbc:mysql://localhost/"+
					    "E_SHOP?user=root&password="+
					    "y256rety");
	    
	    // Do something with the Connection
	    
	}
	catch (SQLException E) {
	    System.out.println("SQLException: " + E.getMessage());
	    System.out.println("SQLState:     " + E.getSQLState());
	    System.out.println("VendorError:  " + E.getErrorCode());
	}
	
       return C;
    }	    

    protected abstract Object currentRecordAsObject(Hashtable record);
    
    public Object materializeWith(Object anOID)
    {
	System.out.println("Aufruf materializeWith");
	
	Object obj = 
	    currentRecordAsObject(selectFirst(oidColumn+"="+
					      anOID));
	if (obj!=null)
	    myCache.add(anOID, obj,true);
	return obj;
    }
    
} // RelationalPFWBroker
