package de.huberlin.elab.pfw;

/**
 *  Diese Klasse ist Teil des Persistance-Frameworks.
 *
 *  @author Erik Pischel
 */
public abstract class VirtualProxy
{
    
    /** Object Identifier */
    protected Integer oid; 
    protected Object realSubject = null;
    protected PFWBroker broker = null;

    public VirtualProxy(Integer oid)
    {
	this.oid = oid;
    }
    
    protected Object getRealSubject() 
    {
	if (realSubject==null)
	    materializeObject();

	return realSubject;
    }

    protected void materializeObject() {
	realSubject = getRealSubject();
    }

    protected PFWBroker getBroker()
    {
	if (broker==null)
	    broker = createBroker();
	return broker;
    }

    protected abstract PFWBroker createBroker();
    
}
